//**********************************************************************************
//                                                                                  
//        _   _       _        ___  ___      _        ___  ___          _             
//       | | | |     | |       |  \/  |     | |       |  \/  |         | |            
//       | |_| | ___ | |_   _  | .  . | ___ | |_   _  | .  . | ___   __| |___       
//       |  _  |/ _ \| | | | | | |\/| |/ _ \| | | | | | |\/| |/ _ \ / _` / __|      
//       | | | | (_) | | |_| | | |  | | (_) | | |_| | | |  | | (_) | (_| \__ \      
//       \_| |_/\___/|_|\__, | \_|  |_/\___/|_|\__, | \_|  |_/\___/ \__,_|___/      
//                       __/ |                  __/ |                               
//                      |___/                  |___/                                
//                                                                                  
//                       Website: http://www.holymolymods.com                       
//*********************************************************************************
// Coded for Openwarfare Mod by [105]HolyMoly  Jan.20/2012
// V.2.0 Final

#include maps\mp\_utility;
#include maps\mp\gametypes\_hud_util;
#include openwarfare\_utils;

/*
	Kill Confirmed
	Objective: 	Score points for your team by eliminating players on the opposing team and collecting their dog tags
	Map ends:	When one team reaches the score limit, or time limit is reached
	Respawning:	No wait / Near teammates

	Level requirements
	------------------
		Spawnpoints:
			classname		mp_tdm_spawn
			All players spawn from these. The spawnpoint chosen is dependent on the current locations of teammates and enemies
			at the time of spawn. Players generally spawn behind their teammates relative to the direction of enemies.

		Spectator Spawnpoints:
			classname		mp_global_intermission
			Spectators spawn from these and intermission is viewed from these positions.
			Atleast one is required, any more and they are randomly chosen between.

	Level script requirements
	-------------------------
		Team Definitions:
			game["allies"] = "marines";
			game["axis"] = "opfor";
			This sets the nationalities of the teams. Allies can be american, british, or russian. Axis can be german.

		If using minefields or exploders:
			maps\mp\_load::main();

	Optional level script settings
	------------------------------
		Soldier Type and Variation:
			game["american_soldiertype"] = "normandy";
			game["german_soldiertype"] = "normandy";
			This sets what character models are used for each nationality on a particular map.

			Valid settings:
				american_soldiertype	normandy
				british_soldiertype		normandy, africa
				russian_soldiertype		coats, padded
				german_soldiertype		normandy, africa, winterlight, winterdark
*/

/*QUAKED mp_tdm_spawn (0.0 0.0 1.0) (-16 -16 0) (16 16 72)
Players spawn away from enemies and near their team at one of these positions.*/

/*QUAKED mp_tdm_spawn_axis_start (0.5 0.0 1.0) (-16 -16 0) (16 16 72)
Axis players spawn away from enemies and near their team at one of these positions at the start of a round.*/

/*QUAKED mp_tdm_spawn_allies_start (0.0 0.5 1.0) (-16 -16 0) (16 16 72)
Allied players spawn away from enemies and near their team at one of these positions at the start of a round.*/

main()
{

	if(getdvar("mapname") == "mp_background")
		return;

	// Disable the following module	
	setDvar( "scr_dogtags_enable_kc", "0" );
		
	if ( !isdefined( game["switchedsides"] ) )
		game["switchedsides"] = false;		
	
	level.scr_kc_forcestartspawns = getdvarx( "scr_kc_forcestartspawns", "int", 0, 0, 1 );
	level.scr_kc_dogtag_autoremoval_time = getdvarx( "scr_kc_dogtag_autoremoval_time", "int", 15, 5, 60 );
	level.scr_kc_enemy_dogtag_score = getdvarx( "scr_kc_enemy_dogtag_score", "int", 10, 0, 500 );
        level.scr_kc_team_dogtag_score = getdvarx( "scr_kc_team_dogtag_score", "int", 5, 0, 500 );
        level.scr_kc_dogtag_obits = getdvarx( "scr_kc_dogtag_obits", "int", 1, 0, 1 );
        level.scr_kc_denied_player_sound = getdvarx( "scr_kc_denied_player_sound", "int", 0, 0, 1 );
        level.scr_kc_denied_team_sound = getdvarx( "scr_kc_denied_team_sound", "int", 1, 0, 1 );
        level.scr_kc_show_dogtags_minimap = getdvarx( "scr_kc_show_dogtags_minimap", "int", 1, 0, 1 );
        level.scr_kc_dogtags_explode_fx = getdvarx( "scr_kc_dogtags_explode_fx", "int", 1, 0, 1 );
        level.scr_kc_dogtag_retrieve_score = getdvarx( "scr_kc_dogtag_retrieve_score", "int", 30, 0, 500 );
        level.scr_kc_dogtag_attacker_owner_score = getdvarx( "scr_kc_dogtag_attacker_owner_score", "int", 20, 0, 500 );
	
	maps\mp\gametypes\_globallogic::init();
	maps\mp\gametypes\_callbacksetup::SetupCallbacks();
	maps\mp\gametypes\_globallogic::SetupCallbacks();

	maps\mp\gametypes\_globallogic::registerNumLivesDvar( level.gameType, 0, 0, 10 );
	maps\mp\gametypes\_globallogic::registerRoundLimitDvar( level.gameType, 0, 0, 500 );
	maps\mp\gametypes\_globallogic::registerRoundSwitchDvar( level.gameType, 0, 0, 500 );
	maps\mp\gametypes\_globallogic::registerScoreLimitDvar( level.gameType, 1500, 0, 5000 );
	maps\mp\gametypes\_globallogic::registerTimeLimitDvar( level.gameType, 20, 0, 1440 );

	level.teamBased = true;
	level.overrideTeamScore = true;

	level.onPrecacheGameType = ::onPrecacheGameType;
	level.onStartGameType = ::onStartGameType;
	level.onSpawnPlayer = ::onSpawnPlayer;
        level.onPlayerKilled = ::onPlayerKilled;
	level.onRoundSwitch = ::onRoundSwitch;


	game["dialog"]["gametype"] = gameTypeDialog( "kill_confirmed" );

	game["dialog"]["offense_obj"] = "kc_boost";
	game["dialog"]["defense_obj"] = "kc_boost";

}

onPrecacheGameType()
{

	precacheShader( "dogtag" );
        precacheModel( "skull_ddogtag" );
        precacheModel( "cross_ddogtag" );

        game[level.gameType]["cross_fx"] = loadfx( "impacts/dogtag_explode_white" );
        game[level.gameType]["skull_fx"] = loadfx( "impacts/dogtag_explode_red" ); 
  
}

onStartGameType()
{
	setClientNameMode("auto_change");

	maps\mp\gametypes\_globallogic::setObjectiveText( "allies", &"OW_OBJECTIVES_KC" );
	maps\mp\gametypes\_globallogic::setObjectiveText( "axis", &"OW_OBJECTIVES_KC" );
	
	if ( level.splitscreen )
	{
		maps\mp\gametypes\_globallogic::setObjectiveScoreText( "allies", &"OW_OBJECTIVES_KC" );
		maps\mp\gametypes\_globallogic::setObjectiveScoreText( "axis", &"OW_OBJECTIVES_KC" );
	}
	else
	{
		maps\mp\gametypes\_globallogic::setObjectiveScoreText( "allies", &"OW_OBJECTIVES_KC_SCORE" );
		maps\mp\gametypes\_globallogic::setObjectiveScoreText( "axis", &"OW_OBJECTIVES_KC_SCORE" );
	}
	maps\mp\gametypes\_globallogic::setObjectiveHintText( "allies", &"OW_OBJECTIVES_KC_HINT" );
	maps\mp\gametypes\_globallogic::setObjectiveHintText( "axis", &"OW_OBJECTIVES_KC_HINT" );
			
	level.spawnMins = ( 0, 0, 0 );
	level.spawnMaxs = ( 0, 0, 0 );
	maps\mp\gametypes\_spawnlogic::placeSpawnPoints( "mp_tdm_spawn_allies_start" );
	maps\mp\gametypes\_spawnlogic::placeSpawnPoints( "mp_tdm_spawn_axis_start" );
	maps\mp\gametypes\_spawnlogic::addSpawnPoints( "allies", "mp_tdm_spawn" );
	maps\mp\gametypes\_spawnlogic::addSpawnPoints( "axis", "mp_tdm_spawn" );
	
	level.mapCenter = maps\mp\gametypes\_spawnlogic::findBoxCenter( level.spawnMins, level.spawnMaxs );
	setMapCenter( level.mapCenter );
	
	allowed[0] = "war";
	
	if ( getDvarInt( "scr_oldHardpoints" ) > 0 )
		allowed[1] = "hardpoint";
	
	level.displayRoundEndText = false;
	maps\mp\gametypes\_gameobjects::main(allowed);
	
	// elimination style
	if ( level.roundLimit != 1 && level.numLives )
	{
		level.overrideTeamScore = true;
		level.displayRoundEndText = true;
		level.onDeadEvent = ::onDeadEvent;
	}

        //Dogtag ObjIds
        level.dogtagObjIds = 0;     

}

onSpawnPlayer()
{
	// Check which spawn points should be used
	if ( game["switchedsides"] ) {
		spawnTeam = level.otherTeam[ self.pers["team"] ];
	} else {
		spawnTeam =  self.pers["team"];
	}

	self.usingObj = undefined;

	if ( level.inGracePeriod || level.scr_kc_forcestartspawns )
	{
		spawnPoints = getentarray("mp_tdm_spawn_" + spawnTeam + "_start", "classname");
		
		if ( !spawnPoints.size )
			spawnPoints = getentarray("mp_sab_spawn_" + spawnTeam + "_start", "classname");
			
		if ( !spawnPoints.size )
		{
			spawnPoints = maps\mp\gametypes\_spawnlogic::getTeamSpawnPoints( spawnTeam );
			spawnPoint = maps\mp\gametypes\_spawnlogic::getSpawnpoint_NearTeam( spawnPoints );
		}
		else
		{
			spawnPoint = maps\mp\gametypes\_spawnlogic::getSpawnpoint_Random( spawnPoints );
		}		
	}
	else
	{
		spawnPoints = maps\mp\gametypes\_spawnlogic::getTeamSpawnPoints( spawnTeam );
		spawnPoint = maps\mp\gametypes\_spawnlogic::getSpawnpoint_NearTeam( spawnPoints );
	}


	if ( !isDefined( self.carryIcon ) ) {
		self.carryIcon = self createIcon( "dogtag", 50, 50 );
		self.carryIcon setPoint( "CENTER", "CENTER", 220, 140 );
		self.carryIcon.archived = true;
		self.carryIcon.hideWhenInMenu = true;
		self.carryIcon.sort = -3;
		self.carryIcon.alpha = 0;
	}

	
	self spawn( spawnpoint.origin, spawnpoint.angles );

}

onDeadEvent( team )
{
	// Make sure players on both teams were not eliminated
	if ( team != "all" ) {
		[[level._setTeamScore]]( getOtherTeam(team), [[level._getTeamScore]]( getOtherTeam(team) ) + 1 );
		thread maps\mp\gametypes\_globallogic::endGame( getOtherTeam(team), game["strings"][team + "_eliminated"] );
	} else {
		// We can't determine a winner if everyone died like in S&D so we declare a tie
		thread maps\mp\gametypes\_globallogic::endGame( "tie", game["strings"]["round_draw"] );
	}
}


onRoundSwitch()
{
	// Just change the value for the variable controlling which map assets will be assigned to each team
	level.halftimeType = "halftime";
	game["switchedsides"] = !game["switchedsides"];
}
            
onPlayerKilled( eInflictor, attacker, iDamage, sMeansOfDeath, sWeapon, vDir, sHitLoc, psOffsetTime, deathAnimDuration )
{
        // No dropped tag if going to spectate, killing yourself or teammate kills you!
        if( isPlayer( attacker ) && self.pers["team"] != attacker.pers["team"] && attacker != self ) 
        {
                if( self.pers["team"] != "spectator" ) 
                {
                        // Place spawnpoint on the ground based on player box size 
                        basePosition = playerPhysicsTrace( self.origin, self.origin + ( 0, 0, -99999 ) );

                        // Create pickup trigger
                        trigger = spawn( "trigger_radius", basePosition, 0, 20, 50 );
                        trigger endon( "picked_up" );
                        trigger endon( "timed_out" );
                        trigger.owner = attacker; // Attacker retrieval points
                        trigger.team = attacker.pers["team"];

                        // Friendly tags
	                friendlyTag = spawn( "script_model", basePosition + ( 0, 0, 20 ) );
                        friendlyTag endon( "picked_up" );
                        friendlyTag endon( "timed_out" );
	                friendlyTag setModel( "cross_ddogtag" );
	                friendlyTag.team = self.pers["team"];
                        friendlyTag.owner = self;

	                // Enemy tags
	                enemyTag = spawn( "script_model", basePosition + ( 0, 0, 20 ) );
                        enemyTag endon( "picked_up" );
                        enemyTag endon( "timed_out" );
	                enemyTag setModel( "skull_ddogtag" );
	                enemyTag.team = attacker.pers["team"];
                        enemyTag.owner = self;

                        //Rotate
                        friendlyTag thread rotate();
                        enemyTag thread rotate();

                        // Show tags to proper teams
                        friendlyTag thread showTagToTeam();
                        enemyTag thread showTagToTeam();

                        // Show friendly tag locations on minimap ( only 14 Tag Obj Ids will show at once )
                        if( level.scr_kc_show_dogtags_minimap == 1 && level.dogtagObjIds < 14 ) { // 14 tags + 1 Hardpoint( possible) = 15 max allowed Ids
                                enemyTag thread showOnMinimap( basePosition );
                        }

                        // Wait for another player to pickup the dogtags
                        trigger thread removeTriggerOnPickup( friendlyTag, enemyTag, trigger );

                        // Remove the trigger and dogtags if the dog tag expire
                        trigger thread removeTriggerOnTimeout( friendlyTag, enemyTag, trigger );

                }

        }


} 

removeTriggerOnTimeout( friendlyTag, enemyTag, trigger )
{

	trigger endon( "picked_up" );
	friendlyTag endon( "picked_up" );
	enemyTag endon( "picked_up" );
	
	// Wait for this tag to timeout
	wait( level.scr_kc_dogtag_autoremoval_time );

        // Play fx for Tag model explode
        if( level.scr_kc_dogtags_explode_fx == 1 ) {

                team = trigger.team;

                // Red FX
                enemyTag.fx = spawnFx( game[level.gameType]["skull_fx"], enemyTag.origin );
                wait( 0.05 );
                triggerFx( enemyTag.fx );
                enemyTag.fx thread showFxToTeam( team );

                // White FX
                friendlyTag.fx = spawnFx( game[level.gameType]["cross_fx"], friendlyTag.origin );
                wait( 0.05 );
                triggerFx( friendlyTag.fx );
                friendlyTag.fx thread showFxToTeam( level.otherTeam[ team ] );
                
        }

	// Notify trigger and model timed out
	trigger notify( "timed_out" );
	friendlyTag notify( "timed_out" );
	enemyTag notify( "timed_out" );

        // Delete Trigger and Model
	trigger delete();	
	friendlyTag delete();
	enemyTag delete();
	
}

removeTriggerOnPickup( friendlyTag, enemyTag, trigger )
{ 
           
        trigger endon( "timed_out" );
        friendlyTag endon( "timed_out" );
        enemyTag endon( "timed_out" );

        trigger waittill( "trigger", player );
        
        // If by some chance a dead player activates the trigger, the dogtag will simply be deleted!
        if ( isAlive( player ) ) {

                // Cannot pick up dogtag if in spawn protection.......may be Invisible
	        if( isDefined( player.spawn_protected ) && player.spawn_protected == true ) {
                        player thread removeTriggerOnPickup( friendlyTag, enemyTag, trigger );
                        return;
                }

                // Friendly team picks up Dogtag
                if( player.pers["team"] == friendlyTag.team ) {

                        if ( level.scr_kc_denied_player_sound == 1 ) 
                                player playLocalSound( "denied_kc" );
          
                        //Play sound to other team
                        if ( level.scr_kc_denied_team_sound == 1 && friendlyTag.team == "allies" ) 
                                playSoundOnPlayers( "denied_kc", "axis" );

                        if ( level.scr_kc_denied_team_sound ==1  && friendlyTag.team == "axis" ) 
                                playSoundOnPlayers( "denied_kc", "allies" );

                        player.carryIcon.alpha = 1;
                        player.carryIcon fadeOverTime( 1.3 );
                        player.carryIcon.alpha = 0;

                        // Show assist point for saving friendly
			player maps\mp\gametypes\_globallogic::incPersStat( "assists", 1 );
			player.assists = player maps\mp\gametypes\_globallogic::getPersStat( "assists" );
                        
                        // Give player a score 
                        player thread givePlayerScore( "take", level.scr_kc_team_dogtag_score );

                        // Give team a score                                               
                        [[level._setTeamScore]]( player.pers["team"], [[level._getTeamScore]]( player.pers["team"] ) + level.scr_kc_team_dogtag_score );

                        // Send notice to players according 
                        if ( level.scr_kc_dogtag_obits == 1  ) 
                                iprintln("^7" + player.name + " .... Kill Denied !");

	                player logString( player.pers["team"] + " " + "kill denied" );
	                lpselfnum = player getEntityNumber();
	                lpGuid = player getGuid();
	                logPrint("KD;" + lpGuid + ";" + lpselfnum + ";" + player.name + "\n");

                }
   
                // Enemy team picks up DogTag 
                if ( player.pers["team"] == enemyTag.team ) {

                        if( isDefined( player ) && isAlive( player ) ) {
                                sayTeamVoice( player, "1mc_killconfirmed", true );
                        }
        
                        player.carryIcon.alpha = 1;
                        player.carryIcon fadeOverTime( 1.3 );
                        player.carryIcon.alpha = 0;

                        // Give player a score 
                        player thread givePlayerScore( "take", level.scr_kc_enemy_dogtag_score );

                        // Give team a score                                               
                        [[level._setTeamScore]]( player.pers["team"], [[level._getTeamScore]]( player.pers["team"] ) + level.scr_kc_enemy_dogtag_score );

                        // Send notice to players 
                        if ( level.scr_kc_dogtag_obits == 1 ) 
                                iprintln("^1" + player.name + " ^7.... Kill Confirmed !");

	                player logString( player.pers["team"] + " " + "kill confirmed" );
	                lpselfnum = player getEntityNumber();
	                lpGuid = player getGuid();
	                logPrint("KC;" + lpGuid + ";" + lpselfnum + ";" + player.name + "\n");

                }

                // Retrievel Bonus Score 
                if( friendlyTag.owner == player ) {

	                notifyData = spawnStruct();
	                notifyData.titleText = "Retrieval Bonus";
	                notifyData.notifyText ="Recovered Your Own DogTags!";
	                notifyData.iconName = "dogtag";

	                if( player.pers["team"] == "allies" ) {
                                notifyData.glowColor = ( 1, 1, 0 ); // Yellow
                        } else {
                                notifyData.glowColor = ( 1, 0, 0 ); // Red
                        }

	                notifyData.duration = 4.0;

                        player thread maps\mp\gametypes\_hud_message::notifyMessage( notifyData );

                        // Give player a score 
                        player thread givePlayerScore( "defend", level.scr_kc_dogtag_retrieve_score - level.scr_kc_team_dogtag_score );

                        // Give team a score                                               
                        [[level._setTeamScore]]( player.pers["team"], [[level._getTeamScore]]( player.pers["team"] ) + ( level.scr_kc_dogtag_retrieve_score - level.scr_kc_team_dogtag_score ) );

                }

                // Points for retrieving dogtags from the enemy the attacker killed
                if( trigger.owner == player ) {

                        // Give player a score 
                        player thread givePlayerScore( "take", level.scr_kc_dogtag_attacker_owner_score - level.scr_kc_enemy_dogtag_score );

                        // Give team a score                                               
                        [[level._setTeamScore]]( player.pers["team"], [[level._getTeamScore]]( player.pers["team"] ) + ( level.scr_kc_dogtag_attacker_owner_score - level.scr_kc_enemy_dogtag_score ) );

                }


        }

        trigger playSound( "dogtag_kc_pickup" );

        // Notify trigger and model picked up
        trigger notify( "picked_up" );
        friendlyTag notify( "picked_up" );
        enemyTag notify( "picked_up" );

        // Delete Trigger and Model
        trigger delete();
	friendlyTag delete();
        enemyTag delete ();

}

showOnMinimap( position )
{
	// Get the next objective ID to use
	objCompass = maps\mp\gametypes\_gameobjects::getNextObjID();
	if ( objCompass != -1 ) {
		objective_add( objCompass, "active", position + ( 0, 0, 25 ) );
		objective_icon( objCompass, "dogtag" );
                objective_team( objCompass, self.team );

                level.dogtagObjIds++;

	}
	
	self waittill( "death" );
	
	// Delete the objective
	if ( objCompass != -1 ) {
		objective_delete( objCompass );
		maps\mp\gametypes\_gameobjects::resetObjID( objCompass );

                level.dogtagObjIds--;
	}

} 

givePlayerScore( event, score )
{
	self maps\mp\gametypes\_rank::giveRankXP( event, score );
		
	self.pers["score"] += score;
	self maps\mp\gametypes\_persistence::statAdd( "score", ( self.pers["score"] - score ) );
	self.score = self.pers["score"];
	self notify ( "update_playerscore_hud" );
}

rotate()

{
	self endon( "picked_up" );
	self endon( "timed_out" );


	while( true )

	{

           self movez( 20, 1.5, 0.3, 0.3 );

	   self rotateyaw( 360, 1.5, 0, 0 );

	   wait( 1.5 );

	   self movez( -20, 1.5, 0.3, 0.3 );

	   self rotateyaw( 360 ,1.5, 0, 0 );

	   wait( 1.5 );

	}

}	

showTagToTeam()
{

        while( isDefined( self ) ) // use while() in case player changes team!
        {
               self hide();

               for( i = 0 ; i < level.players.size ; i ++ )
               {
                       player = level.players[i];

                       if ( player.pers["team"] == self.team ) {
                               self showToPlayer( player );
                       }

               }

               wait( 0.05 );
        }

}

showFxToTeam( team )
{

        if( isDefined( self ) )
        {
               self hide();

               for( i = 0 ; i < level.players.size ; i ++ )
               {
                       player = level.players[i];

                       if ( player.pers["team"] == team ) {
                               self showToPlayer( player );
                       }

               }

        }

}